// -----------------------------------------------------------------------------
// COPYRIGHT (C) 2020 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 26 Oct, 2020 
//
// THIS FILE IS A PART OF LSF_Toolbox 
// -----------------------------------------------------------------------------


function ChooseMethod(handles)
	handles.PolyOrderText.visible = "off"
	handles.PolyOrderEntry.visible = "off"
	handles.ChooseIntText.visible = "off"
	handles.ChooseIntMethod.visible = "off"
	value = handles.ChooseMethod.value
	select value
	case 1 then
		LiniarBtn_Callback(handles)
	case 2 then
		handles.PolyOrderText.visible = "on"
		handles.PolyOrderEntry.visible = "on"
		PolyFitBtn_Callback(handles)
	case 3 then
		ExpBtn_callback(handles)
	case 4 then
		PowerFnBtn_callback(handles)
	case 5 then
		handles.ChooseIntText.visible = "on"
		handles.ChooseIntMethod.visible = "on"
		ChooseIntMethod(handles)
	case 6 then
		[x,y] =  Data()
		n = size(x)(1)
		if n==1 then
			messagebox("Fitting is not possible please enter more data points ", "Error!!", "error");
			return;
		end
		X = linspace(min(x),max(x),5000)
		d = X(2)-X(1)
		Y=smooth([x';y'],d);
		plot(x,y,".k",Y(1,:)',Y(2,:)',"m","thickness",3);
		LegStr = "Smooth Spline";
		LabelGraph(handles, LegStr, 2);
		InsertTable(handles,"Smooth Spline", 0,1, 0, %nan,%nan, n)
	else
		error("Error")
	end
endfunction
