// -----------------------------------------------------------------------------
// COPYRIGHT (C) 2020 - AUTHOR - MANISH JOSHI
//
// CREATED USING SCILAB-6.1.0 ON WINDOWS-10 64-bit
//
// DATE OF CREATION: 26 Oct, 2020 
//
// THIS FILE IS A PART OF LSF_Toolbox 
// -----------------------------------------------------------------------------


// THIS IS A CALLBACK FUNCTION FOR LINEAR FIT BUTTON (y = mx +c)
function LiniarBtn_Callback(handles)
	[x,y] =  Data()
	n = size(x)(1)
	if n==1 then
		messagebox("Fitting is not possible please enter more data points ", "Error!!", "error");
		return;
	end
	dx = (max(x)- min(x))/5
	X = linspace(min(x)-dx,max(x)+dx,1000)
	A =[sum(x.^2), sum(x); sum(x),n];
	C=[sum(x.*y); sum(y)];

	M = A\C;
	Y = M(1)*X + M(2);
	// Goodness of fit
	YR = M(1)*x + M(2);
	Ymean = sum(YR)/n;
	SSR = sum((Ymean-YR).^2);
	SSE = sum((y-YR).^2);
	SST = SSE + SSR;
	Rsqr = SSR/SST;
	DFE = n-2;
	if n == 2 then
			ARsqr = %nan;
			RMSE = %nan;
		else
			ARsqr = 1-((1-Rsqr)*(n-1)/(n-2));
			RMSE = sqrt(SSE/(n-2))
		end
	plot(x,y,"k.",X,Y,"k","thickness",3);
	LegStr = msprintf("y = %0.3G x + %0.3G (Fitted Line)",M(1),M(2));
	LabelGraph(handles, LegStr, 2)
	ResultStr = "======= Liniar Fitting =======\n\n"+...
	msprintf("Slope = %0.4G    Y-intercept = %0.4G",M(1),M(2)) +"\n\n Equation of Fitted Line : \n "+...
	msprintf("   Y = %0.4G X + %0.4G",M(1),M(2))+ "\n\nGoodness of fit : \n " + ....
	msprintf("  SSE = %g ", SSE)+  "\n" + msprintf("   R^2= %g ", Rsqr)+  "\n" + msprintf("   DFE = %g ", DFE)+  "\n" + ....
	msprintf("   Adj. R^2 = %g ", ARsqr)+  "\n" + msprintf("   RMSE = %g ", RMSE)+  "\n" ;
	InsertTable(handles,"Linear", SSE,Rsqr, DFE, ARsqr, RMSE, 2)
	ResultString(handles,ResultStr)
endfunction
